package worker;

import halloechen.JoalJFrame;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import javax.swing.border.Border;
import java.util.ArrayList;
import java.util.concurrent.Executors; 
import java.util.concurrent.ExecutorService; 
import java.util.Date;

public class CarloUI implements ActionListener {

JoalJFrame myframe;
JButton thrstart;
JButton thrstop;
Long seconds;
Long statcyc;
Long oldstatcyc;
public JTextField time;
public JTextField numtr;
public JTextField speed;
public JTextField cycles;
private ArrayList<CarloWorker> cw;
private ArrayList<Long> cylist;
long fixsum=0L;
ExecutorService exec;
int randtype;


public CarloUI(String[] args)  {
	cw = new ArrayList<CarloWorker>();
	cylist = new ArrayList<Long>();
	seconds = (new Date()).getTime();
	statcyc = 0L;
	oldstatcyc = 0L;
	if (args.length == 0) {randtype = 0;} else {randtype = Integer.parseInt(args[0]);}
	System.out.println("Random-Typ: "+randtype);
	createAndShowGUI();
	CarloAggregator ca = new CarloAggregator(this);
	ca.execute();
	exec = Executors.newCachedThreadPool(); 
}

void createAndShowGUI() {
	myframe = new JoalJFrame("MonsterChecker");
	myframe.setDefaultCloseOperation(JoalJFrame.DISPOSE_ON_CLOSE);
	myframe.setLayout(new BorderLayout());
	Border border10 = BorderFactory.createEmptyBorder(10,10, 10, 10);
	JPanel outpanel = new JPanel();
	outpanel.setBorder(border10);
	JLabel labtime = new JLabel("Dauer",JLabel.CENTER);
	JLabel labcycles = new JLabel("Zyklen",JLabel.CENTER);
	JLabel labspeed = new JLabel("Geschwindigkeit",JLabel.CENTER);
	JLabel labnumtr = new JLabel("Anzahl Threads",JLabel.CENTER);
	GridLayout gridlay = new GridLayout(2,4);
	gridlay.setHgap(10);
	outpanel.setLayout(gridlay);	
	Border border = BorderFactory.createLoweredBevelBorder();
	time = new JTextField(15);
	cycles = new JTextField(15);
	speed = new JTextField(15);
	numtr = new JTextField(10);
    time.setEditable(false);
    time.setHorizontalAlignment(JTextField.RIGHT);
    time.setBorder(border);
    cycles.setEditable(false);
    cycles.setHorizontalAlignment(JTextField.RIGHT);
    cycles.setBorder(border);
    speed.setEditable(false);
    speed.setHorizontalAlignment(JTextField.RIGHT);
    speed.setBorder(border);
    numtr.setEditable(false);
    numtr.setBorder(border);
    numtr.setHorizontalAlignment(JTextField.RIGHT);
	outpanel.add(labtime);
    outpanel.add(labcycles);
    outpanel.add(labspeed);
    outpanel.add(labnumtr);
    outpanel.add(time);
	outpanel.add(cycles);
	outpanel.add(speed);
	outpanel.add(numtr);
	JPanel butpanel = new JPanel();
	JButton ende = new JButton("Ende");
	ende.addActionListener(this);
	thrstart = new JButton("Thread starten");
	thrstart.addActionListener(new PlusThr(this));
	thrstop = new JButton("Thread stoppen");
	thrstop.setEnabled(false);	
	thrstop.addActionListener(new MinusThr());
	butpanel.add(thrstart);
	butpanel.add(thrstop);
	butpanel.add(ende);
    myframe.add(outpanel,BorderLayout.CENTER);
	myframe.add(butpanel,BorderLayout.PAGE_END);
	myframe.pack();
	myframe.setVisible(true);
}

public void updateResults(CarloPacket data) {
	Long sum = 0L;
	cylist.set(data.id, data.cycles);
	for (Long c: cylist) {
		sum+=c;
	}
	statcyc = sum+fixsum;
	cycles.setText(Long.toString(statcyc));
}

public void bringFinalResults (CarloPacket data) {
	updateResults(data);
	fixsum+=cylist.get(CarloWorker.workercounter-1);
	cylist.set(CarloWorker.workercounter-1,0L);
	cylist.remove(CarloWorker.workercounter-1);
	CarloWorker.workercounter--;
	numtr.setText(Integer.toString(CarloWorker.workercounter));
	cw.remove(CarloWorker.workercounter);
	if (CarloWorker.workercounter == 0) {
		thrstop.setEnabled(false);
	}
	System.out.println(cw.size()+" CarloWorker übrig.");
}
public void updateTiming() {
	time.setText(Long.toString(Math.round(Math.floor  (  ( (new Date()).getTime()-seconds) /1000) ) ));
	speed.setText(Long.toString(statcyc-oldstatcyc));
	oldstatcyc = statcyc;
}

public void actionPerformed(ActionEvent e) {
	System.exit(0);
}

class PlusThr implements ActionListener { 
	CarloUI cui;
	public PlusThr(CarloUI _cui){
		cui = _cui;
	}
	public void actionPerformed(ActionEvent aev) { 
		cw.add(new CarloWorker(cui));
		if (cylist.size()<CarloWorker.workercounter) { 
		 cylist.add(0L);
		}		
		System.out.print("Es wurde CarloWorker Nr. "+(CarloWorker.workercounter)+" gestartet.\n");
		exec.execute(cw.get(CarloWorker.workercounter-1));
		numtr.setText(Integer.toString(CarloWorker.workercounter));
		thrstop.setEnabled(true);
	}
}

class MinusThr implements ActionListener { 
	public void actionPerformed(ActionEvent aev) { 
		cw.get(CarloWorker.workercounter-1).aufhoeren(true);
	}
}

}